<?php
namespace Drupal\content_export_csv\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\JsonResponse;
use \Drupal\node\Entity\Node;

class ContentExportController extends ControllerBase{
	public function getContentType(){
		$contentTypes = \Drupal::service('entity.manager')->getStorage('node_type')->loadMultiple();
		$contentTypesList = [];
		foreach ($contentTypes as $contentType) {
    		$contentTypesList[$contentType->id()] = $contentType->label();
		}
		return $contentTypesList;
	}


	function getNodeIds($nodeType){
		\Drupal::logger('node-type')->notice($nodeType);
		$entityQuery = \Drupal::entityQuery('node');
		$entityQuery->condition('status',1);
		$entityQuery->condition('type',$nodeType);
		$entityIds = $entityQuery->execute();
		return $entityIds;
	}

	function getNodeDataList($entityIds,$nodeType){
		$nodeData = Node::loadMultiple($entityIds);
 		foreach($nodeData as $nodeDataEach){
 		$nodeCsvData[] = implode(',',ContentExportController::getNodeData($nodeDataEach,$nodeType)); 		
 		}
 		return $nodeCsvData;
	}

	function getValidFieldList($nodeType){
		$nodeArticleFields = \Drupal::entityManager()->getFieldDefinitions('node',$nodeType);
		$nodeFields = array_keys($nodeArticleFields);
		$unwantedFields = array('comment','sticky','revision_default','revision_translation_affected','revision_timestamp','revision_uid','revision_log','vid','uuid','promote');
		
		foreach($unwantedFields as $unwantedField){
			$unwantedFieldKey = array_search($unwantedField,$nodeFields);
			unset($nodeFields[$unwantedFieldKey]);	
		}
		return $nodeFields;		
	}


	function getNodeData($nodeObject,$nodeType){
		$nodeData = array();		
		$nodeFields = ContentExportController::getValidFieldList($nodeType);
		foreach($nodeFields as $nodeField){
			$nodeData[] = (isset($nodeObject->{$nodeField}->value)) ? '"' . $nodeObject->{$nodeField}->value . '"': ((isset($nodeObject->{$nodeField}->target_id)) ? '"' . $nodeObject->{$nodeField}->target_id . '"' : '"' . $nodeObject->{$nodeField}->langcode . '"');			
		}		
		return $nodeData;				
	}

	function getNodeCsvData($nodeType){
		$entityIds = ContentExportController::getNodeIds($nodeType);
		$nodeCsvData = ContentExportController::getNodeDataList($entityIds,$nodeType);
		return $nodeCsvData;
	}
}