<?php

namespace Drupal\content_export_csv\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\content_export_csv\Controller\ContentExportController;

class ContentExportForm extends FormBase{
	public function getFormId(){
		return 'content_export_csv_form';
	}

	public function buildForm(array $form,FormStateInterface $form_state){
		$form['content_type_list'] = [
			'#title'=> $this->t('Content Type'),
			'#type'=> 'select',
			'#options'=> ContentExportController::getContentType()
		];

		$form['export'] = [
			'#value'=> 'Export',
			'#type'=> 'submit' 
		]; 

		return $form;
	}

	public function submitForm(array &$form,FormStateInterface $form_state){
		$nodeType = $form_state->getValue('content_type_list');
		$csvData = ContentExportController::getNodeCsvData($nodeType);
		$filename = 'content_export'. time(). '.csv';
		$csvFile = fopen($filename, "w");
		$fieldNames = implode(',',ContentExportController::getValidFieldList($nodeType));
		fwrite($csvFile,$fieldNames . "\n");
		foreach($csvData as $csvDataRow){
			fwrite($csvFile,$csvDataRow . "\n");
		}
		fclose($csvFile);		
		header('Pragma: public');
		header('Expires: 0');
		header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
		header('Cache-Control: private', false); 
		header('Content-Type: text/csv');
		header('Content-Disposition: attachment; filename="'. basename($filename) . '";');
		header('Content-Transfer-Encoding: binary');
		header('Content-Length: ' . filesize($filename));
		readfile($filename);
		unlink($filename);	
	}
}